---
title: vector-effect
slug: Web/SVG/Attribute/vector-effect
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>vector-effect</code></strong> property specifies the vector effect to use when drawing an object. Vector effects are applied before any of the other compositing operations, i.e. filters, masks and clips.</p>

<p class="note"><strong>Note:</strong> As a presentation attribute, <code>vector-effect</code> can be used as a CSS property.</p>

<p>As a presentation attribute, it can be applied to any element but it has effect only on the following ten elements: {{SVGElement("circle")}}, {{SVGElement("ellipse")}}, {{SVGElement("foreignObject")}}, {{SVGElement("image")}}, {{SVGElement("line")}}, {{SVGElement("path")}}, {{SVGElement("polygon")}}, {{SVGElement("polyline")}}, {{SVGElement("rect")}}, {{SVGElement("text")}}, {{SVGElement("textPath")}} {{SVGElement("tspan")}}, and {{SVGElement("use")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>none</code> | <code>non-scaling-stroke</code> | <code>non-scaling-size</code> | <code>non-rotation</code> | <code>fixed-position</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>none</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>discrete</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>none</code></dt>
 <dd>This value specifies that no vector effect shall be applied, i.e. the default rendering behaviour is used which is to first fill the geometry of a shape with a specified paint, then stroke the outline with a specified paint.</dd>
 <dt><code>non-scaling-stroke</code></dt>
 <dd>This value modifies the way an object is stroked. Normally stroking involves calculating stroke outline of the shapeʼs path in current user coordinate system and filling that outline with the stroke paint (color or gradient). The resulting visual effect of this value is that the stroke width is not dependant on the transformations of the element (including non-uniform scaling and shear transformations) and zoom level.</dd>
 <dt><code>non-scaling-size</code></dt>
 <dd>This value specifies a special user coordinate system used by the element and its descendants. The scale of that user coordinate system does not change in spite of any transformation changes from a host coordinate space. However, it does not specify the suppression of rotation and skew. Also, it does not specify the origin of the user coordinate system. Since this value suppresses scaling of the user coordinate system, it also has the characteristics of <code>non-scaling-stroke</code>.</dd>
 <dt><code>non-rotation</code></dt>
 <dd>This value specifies a special user coordinate system used by the element and its descendants. The rotation and skew of that user coordinate system is suppressed in spite of any transformation changes from a host coordinate space. However, it does not specify the suppression of scaling. Also, it does not specify the origin of user coordinate system.</dd>
 <dt><code>fixed-position</code></dt>
 <dd>This value specifies a special user coordinate system used by the element and its descendants. The position of user coordinate system is fixed in spite of any transformation changes from a host coordinate space. However, it does not specify the suppression of rotation, skew and scaling. When this vector effect and the {{SVGAttr("transform")}} property are defined at the same time, that property is consumed for this effect.</dd>
</dl>

<h2 id="Example">Example</h2>

<h3 id="Example_vector-effectnon-scaling-stroke">Example: vector-effect="non-scaling-stroke"</h3>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 500 240"&gt;
  &lt;!-- normal --&gt;
  &lt;path d="M10,20L40,100L39,200z" stroke="black" stroke-width="2px" fill="none"&gt;&lt;/path&gt;

  &lt;!-- scaled --&gt;
  &lt;path transform="translate(100,0)scale(4,1)" d="M10,20L40,100L39,200z" stroke="black"
      stroke-width="2px" fill="none"&gt;&lt;/path&gt;

  &lt;!-- fixed--&gt;
  &lt;path vector-effect="non-scaling-stroke" transform="translate(300,0)scale(4,1)" d="M10,20L40,100L39,200z"
      stroke="black" stroke-width="2px" fill="none"&gt;&lt;/path&gt;
&lt;/svg&gt;
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Example_vector-effectnon-scaling-stroke", 550, 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "coords.html#VectorEffectProperty", "vector-effect")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.vector-effect")}}</p>
